// Module Author: Biju G.C. 2003.0625
// License: The Mozilla Public License ( http://www.mozilla.org/MPL/ )
// Alternate License: GPL (The all time latest at http://www.gnu.org/copyleft/gpl.html ) 
// Homepage: http://quicktools.mozdev.org/
// 
// 
// 2003.12.23 - Biju G.C. 
//   - JSLIB enabled 
//   - add MacroUtils 


var MacroMenu;  //Declare


// Define Menu object for Macro Editor
// Author: Biju G.C. 2003.0721
MacroMenu = function() 
{

  MacroMenu = new Function();
  MacroMenu.prototype.New = function(){return new this.constructor()};

  MacroMenu.prototype.items = {};

  var oPref    = MacroSettings.PrefObjMacroItem;
  var oPrefAll = MacroSettings.PrefObjMacro;
  var oConst   = MacroConst ;
  var sItemPrefix = oConst.PREFIX + oConst.ITEMPREFIX;

  // Branch to menu action routines
  // Author: Biju G.C. 2003.0721
  MacroMenu.prototype.oncommand = function (itemdata)
  {
    var sScript;
    switch(itemdata)
    {
      case 'editor':  MacroMenu.editor(); return;
      case 'evalnow': MacroMenu.evalnow(); return;
      case 'execnow': MacroMenu.execnow(); return;
      case 'openwin': MacroMenu.openwin(); return;
      default: return eval(oPref.getCharPref('script'+itemdata));
         
    }
  }

  MacroMenu.prototype.runmacrobyid = MacroMenu.prototype.oncommand;
  MacroMenu.prototype.runMacroById = MacroMenu.prototype.oncommand;

  // Author: Biju G.C. 2003.1221
  MacroMenu.prototype.runmacrobyname = function (sName)
  {
   var i;
   try{
      for(i = 1; i <= oConst.MACROCOUNT ;i++) 
      {
        if(sName == oPref.getCharPref('name'+i))
        {
          return eval(oPref.getCharPref('script'+i));
        }
      }
      
      sName = sName.replace(/^\s*/,'').replace(/\s*$/,'');
      for(i = 1; i <= oConst.MACROCOUNT ;i++) 
      {
        if(sName == oPref.getCharPref('name'+i).replace(/^\s*/,'').replace(/\s*$/,''))
        {
          return eval(oPref.getCharPref('script'+i));
        }
      }

      sName = sName.toLowerCase();
      for(i = 1; i <= oConst.MACROCOUNT ;i++) 
      {
        if(sName == oPref.getCharPref('name'+i).toLowerCase().replace(/^\s*/,'').replace(/\s*$/,''))
        {
          return eval(oPref.getCharPref('script'+i));
        }
      }
    }catch(e){}
  }

  MacroMenu.prototype.runMacroByName = MacroMenu.prototype.runmacrobyname ;

  

  // Call Macro editor 
  // Author: Biju G.C. 2003.0721
  MacroMenu.prototype.editor = function (bNoPref)
  {
   window.openDialog('chrome://macroeditor/content/macroeditor.xul','_blank','chrome,resizable');
  }


  // Menu action Evaluate
  // Author: Biju G.C. 2003.0721
  MacroMenu.prototype.evalnow = function (bNoPref)
  {
   var e;
   var sPrefName = "now.eval";
   var s='';

   try{s = oPrefAll.getCharPref(sPrefName);} catch (e){}
      
   try{
       s=prompt('Enter the string to Evaluate',s);
       if(!s) return;
       oPrefAll.setCharPref(sPrefName,s);
       alert(eval(s));
      } catch (e)
      {
       alert('Error while execution');
      }

  }


  // Menu action Execute
  // Author: Biju G.C. 2003.0721
  MacroMenu.prototype.execnow = function (bNoPref)
  {
   var sPrefName = "now.exec";
   var s='';
   try{s = oPrefAll.getCharPref(sPrefName);} catch (e){}
   try{
       s=prompt('Enter the statment to Execute',s);
       if(!s) return;
       oPrefAll.setCharPref(sPrefName,s);
       eval(s);
      } catch (e)
      {
      }

  }


  // Menu action Open new window
  // Author: Biju G.C. 2003.0721
  MacroMenu.prototype.openwin = function (bNoPref)
  {
   var sPrefName = "now.openwin";
   var s='';
   try{s = oPrefAll.getCharPref(sPrefName);} catch (e){}
   try{
       s=prompt('Enter the URL to open',s);
       if(!s) return;
       oPrefAll.setCharPref(sPrefName,s);
       window.open(s);
      } catch (e)
      {
      }

  }



  // Update menu items
  // Author: Biju G.C. 2003.0721
  MacroMenu.prototype.onpopupshowing = function(thismenupopup)
  {
    var oCurrObj;
    var oSepObj = document.getElementById(oConst.PREFIX +"itemsep"+ oConst.MENUSUFIX);        
    oSepObj.removeAttribute('hidden');
    var sItem;
    var i;
    var bFoundItem=false;
    var sMenuIdPrefix = oConst.PREFIX +  oConst.ITEMPREFIX
    var menuarr = [];
    if (!MacroMenu.items['item1'])
    {
     //while(thismenupopup.lastChild) {
     // menuarr.push(thismenupopup.lastChild);
     // thismenupopup.removeChild(thismenupopup.lastChild)
     //}
     for(i = 1; i <= oConst.MACROCOUNT ;i++) 
     {
       oCurrObj = document.createElement("menuitem");
       oCurrObj.setAttribute("id", sMenuIdPrefix + i + oConst.MENUSUFIX);
       oCurrObj.setAttribute("data", i);     
       thismenupopup.appendChild(oCurrObj);
       //thismenupopup.insertBefore(oCurrObj, thismenupopup.firstChild);
       //thismenupopup.insertBefore(oCurrObj, oSepObj);
       MacroMenu.items['item' + i] = oCurrObj;
     }
     //while( menuarr.length) {thismenupopup.appendChild(thismenupopup.pop())}
    }

   for(i=1;i <= oConst.MACROCOUNT; i++)
    {
      if((oPref.getIntPref('flags' +i) & 1) && oPref.getCharPref('name'  +i))
      {
        MacroMenu.items['item' + i].setAttribute("label", oPref.getCharPref('name'  +i));
        MacroMenu.items['item' + i].removeAttribute('hidden');
        bFoundItem=true;
      }  else {
        MacroMenu.items['item' + i].setAttribute('hidden', true);
      }
    }

    if(bFoundItem) {
      oSepObj.removeAttribute('hidden');
    }  else {
      oSepObj.setAttribute('hidden', true);
    }

  }


  // Update read a local file or url
  // Author: Biju G.C. 2003.1221
  MacroMenu.prototype.urlread = function(url)
  {
    var p = new XMLHttpRequest();
    p.open("GET", tofullurl(url), false);
    p.send(null);
    return p.responseText;
  }

  MacroMenu.prototype.urlRead = MacroMenu.prototype.urlread;


  // Update execute a local or url js
  // Author: Biju G.C. 2003.1221
  MacroMenu.prototype.runinsecurejs = function(url)
  {
    var p = new XMLHttpRequest();
    p.open("GET", tofullurl(url), false);
    p.send(null);
    return eval(p.responseText);
  }

  MacroMenu.prototype.runInsecureJS = MacroMenu.prototype.runinsecurejs ;
 
  // checks and load jslib_io 
  // Author: Biju G.C. 2003.1221
  MacroMenu.prototype.jslib = false;
  try {
    include (jslib_io);
    include (jslib_rdf);
    include (jslib_rdffile);
    include (jslib_rdfcontainer);
    include (jslib_rdfresource);
    MacroMenu.prototype.jslib = true;
  }catch(e){}

  // Author: Biju G. C. 2003.0925
  function tofullurl(url,base,search)
  {
    base || (base='file:///');

    url=url.replace(/^\s*/,'')
           .replace(/\s*$/,'');
    var u = url.toLowerCase();
      
    var noturl=(u.search(/^[hf]tt?ps?:\/\//)
              + u.search(/^file:\/\//))==-2;
    noturl && (url=base+escape(url.replace(/\\/g,'/')).replace(/%3A/,':').replace(/%7E/,'~'));
    search && (url+='?'+search);
    return url;
  }

  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.urlfromdospath = function(path)
  {
    return tofullurl(path)
  }
  MacroMenu.prototype.urlFromDOSPath = MacroMenu.prototype.urlfromdospath;


  // Author: Biju G. C. 2003.1221
  function getpathseparator()
  {
    var du=new DirUtils();
    var d = du.getChromeDir();
    if(d.search(/\\/) != -1) return '\\';
    if(d.search(/:/) != -1) return ':';
    return '/';
  }

  MacroMenu.prototype.getpathseparator = getpathseparator;
  MacroMenu.prototype.getPathSeparator = getpathseparator;

  // Author: Biju G. C. 2003.1221
  function ensureparentdirs(path,pathsep)
  {
    if(!path) return false;
    path = path.substr(0,path.length-1)
    pathsep || (pathsep = getpathseparator());
    var pos = path.lastIndexOf(pathsep);
    if (pos < 0) return false;
    var parentpath = path.substr(0, pos);
    var ret;
    var  d = new Dir(parentpath);
    if(!d.exists()) 
    {
      if(!ensureparentdirs(parentpath,pathsep)) return false;
      d.create();
    }
    if(!d.isDir()) return false;
    return true;
  }

  MacroMenu.prototype.ensureparentdirs = ensureparentdirs;
  MacroMenu.prototype.ensureParentDirs = ensureparentdirs;

  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.fileread = function(path)
  {
    var ret='';
    try {
      var f=new File (path); 
      f.open(); 
      ret = f.read(); 
      f.close();
    }catch(e){}
    return ret;
  }

  MacroMenu.prototype.fileRead = MacroMenu.prototype.fileread;

  // Author: Biju G. C. 2003.1222
  MacroMenu.prototype.filewrite = function(path,contents, makeparents)
  {
    var ret=false;
    try {
      if(makeparents && !ensureparentdirs(path)) return ret;
      var f=new File (path); 
      f.open("w"); 
      ret = f.write(contents); 
      f.close();
    }catch(e){}
    return ret;
  }

  MacroMenu.prototype.fileWrite = MacroMenu.prototype.filewrite;

  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.fileappend = function(path,contents, makeparents)
  {
    var ret=false;
    try {
      if(makeparents && !ensureparentdirs(path)) return ret;
      var f=new File (path); 
      f.open("a"); 
      ret = f.write(contents); 
      f.close();
    }catch(e){}
    return ret;
  }

  MacroMenu.prototype.fileAppend = MacroMenu.prototype.fileappend;


  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.filedel = function(path)
  {
    var ret=false;
    try {
      var f=new File (path); 
      ret = f.remove(); 
    }catch(e){}
    return ret;
  }

  MacroMenu.prototype.fileDel = MacroMenu.prototype.filedel;

  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.isfile = function(path)
  {
    var ret=false;
    try {
      var f=new File (path); 
      ret = f.isFile(); 
    }catch(e){}
    return ret;
  }

  MacroMenu.prototype.isFile = MacroMenu.prototype.isfile;


  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.fileexists = function(path)
  {
    var ret=false;
    try {
      var f=new File (path); 
      ret = f.exists(); 
    }catch(e){}
    return ret;
  }

  MacroMenu.prototype.fileExists = MacroMenu.prototype.fileexists;

  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.filesize = function(path)
  {
    var ret;
    try {
      var f=new File (path); 
      ret = f.size; 
    }catch(e){}
    return ret;
  }

  MacroMenu.prototype.fileSize = MacroMenu.prototype.filesize;

  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.filedatemodified = function(aPath)
  {
    var ret;
    try {
      var f=new File (aPath); 
      ret = f.dateModified; 
    }catch(e){}
    return ret;
  }

  MacroMenu.prototype.fileDateModified = MacroMenu.prototype.filedatemodified;

  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.filename = function(aPath)
  {
    var ret="";
    try {
      var f=new File (aPath); 
      ret = f.leaf; 
    }catch(e){}
    return ret;
  }

  MacroMenu.prototype.fileName = MacroMenu.prototype.filename;

  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.filecopy = function(aSource, aDest)
  {
    var ret=false;
    try {
      var fu=new FileUtils(); 
      ret = fu.copy(aSource, aDest);
    }catch(e){}
    return ret;
  }

  MacroMenu.prototype.fileCopy = MacroMenu.prototype.filecopy;

  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.filemove = function(aSource, aDest)
  {
    var ret=false;
    try {
      var f=new File (aSource); 
      ret = f.move(aDest); 
    }catch(e){}
    return ret;
  }

  MacroMenu.prototype.fileMove = MacroMenu.prototype.filemove;

  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.runapp = function(aPath, aArgs)
  {
    var ret=false;
    try {
      var fu=new FileUtils(); 
      ret = fu.run(aPath, aArgs); 
    }catch(e){}
    return ret;
  }

  MacroMenu.prototype.runApp = MacroMenu.prototype.runapp;

  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.dirmake = function(aPath, aPermissions)
  {
    var ret=false;
    try {
      var d=new Dir(aPath); 
      ret = d.create(aPermissions);
    }catch(e){}
    return ret;
  }

  MacroMenu.prototype.dirMake = MacroMenu.prototype.dirmake;

  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.isdir = function(aPath)
  {
    var ret=false;
    try {
      var d=new Dir(aPath); 
      ret = d.isDir();
    }catch(e){}
    return ret;
  }

  MacroMenu.prototype.isDir = MacroMenu.prototype.isdir;

  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.direxists=function(aPath)
  {
    var ret=false;
    try {
      var d=new Dir(aPath); 
      ret = d.exists();
    }catch(e){}
    return ret;
  }

  MacroMenu.prototype.dirExists = MacroMenu.prototype.direxists;

  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.dirdel=function(aPath, aRecursive)
  {
    var ret=false;
    try {
      var d=new Dir(aPath); 
      ret = d.remove(aRecursive);
    }catch(e){}
    return ret;
  }

  MacroMenu.prototype.dirDel = MacroMenu.prototype.dirdel;

  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.dirmove=function(aSource, aDest)
  {
    var ret=false;
    try {
      var d=new Dir(aSource); 
      ret = d.move(aDest);
    }catch(e){}
    return ret;
  }

  MacroMenu.prototype.dirMove = MacroMenu.prototype.dirmove;

  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.dirname=function(aPath)
  {
    var ret="";
    try {
      var d=new Dir(aPath); 
      ret = d.leaf;
    }catch(e){}
    return ret;
  }


  // Author: Biju G. C. 2003.1221
  function dirread(aPath,aRegExpFilter)
  {
    var ret=[];
    var temp;
    var i;
    try {
      var d=new Dir(aPath); 

      if(aRegExpFilter)
      {
        temp = d.readDir();
        for(i = 0; i < temp.length;i++)
        {      
          if (temp[i].leaf.search(aRegExpFilter) > -1) ret.push(temp[i]);
        }
      } else {ret = d.readDir();}  
    }catch(e){}
    return ret;
  }

  MacroMenu.prototype.dirread = dirread;
  MacroMenu.prototype.dirRead = dirread;
  
  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.dirreadnames=function(aPath,aRegExpFilter)
  {  
    var ret=[];
    var temp;
    try {
      temp = dirread(aPath,aRegExpFilter);
      for(i = 0; i < temp.length;i++)
      {
        ret.push(temp[i].leaf);
      }
    }catch(e){}
    return ret;
  }

  MacroMenu.prototype.dirReadNames = MacroMenu.prototype.dirreadnames;
  
  // Convert a object to nane:value pair string
  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.set2string =  function (set, filter)
  {
    if (!set) return "";
    var a = set;
    var s = "";
    var i;
    if (filter) {
      filter = filter.toLowerCase();
      for (i in a) {
        if (i.toLowerCase().indexOf(filter) >= 0) {
          try{s += (i + " : " + a[i] + "\n");}catch(e){}
        }
      }
    } else {
      for (i in a) {
        try{s += (i + " : " + a[i] + "\n");}catch(e){}
      }
    }
    return s;
  }

  MacroMenu.prototype.set2String = MacroMenu.prototype.set2string;


  // get all property names to array
  // Author: Biju G. C. 2003.1221
  MacroMenu.prototype.set2list =  function (set, filter)
  {
    if (!set) return "";
    var a = set;
    var s = [];
    var i;
    if (filter) {
      filter = filter.toLowerCase();
      for (i in a) {
        if (i.toLowerCase().indexOf(filter) >= 0) s.push(i);
      }
    } else {
      for (i in a) s.push(i);
    }
    return s;
  }

  MacroMenu.prototype.set2List = MacroMenu.prototype.set2list;
  
  // Actual Create Instance
  MacroMenu = new MacroMenu();
}


MacroMenu();  // Call to Create Instance

var MacroUtils = MacroMenu;